; examples of cons, car, cdr

(define a (cons 1 2))
(car a)
(cdr a)

(car (cons 3 4))
(cdr (cons 3 4))

(define b (cons a 3))

(car (car b))
(cdr (car b))
(cdr b)

(define c (cons (cons 1 2) (cons 3 4)))

(car (car c))
(cdr (car c))
(car (cdr c))
(cdr (cdr c))


(caar c)
(cdar c)
(cadr c)
(cddr c)

(pair? c)
(pair? (car c))
(pair? (cdr c))
(pair? (caar c))
(pair? (cdar c))

(define d (cons 1 '()))
(car d)
(cdr d)
(null? (car d))
(null? (cdr d))

(define e (cons 1 (cons 2 (cons 3 '()))))
(car e)
(car (cdr e))
(car (cddr e))

(define (zip z)
  (if (pair? z)
      (begin 
        (display (car z))
        (display " ")
        (zip (cdr z)))
      (newline)))

(zip e)